require "import"
import "android.app.*"
import "android.content.pm.*"
import "android.widget.*"
import "android.view.*"
import "android.content.*"
import "java.io.*"
import "android.provider.Settings"
import "android.net.*"
import "android.os.Environment"
local activity = activity
activity.title = "Quản lí ứng dụng của tôi"
local layout = LinearLayout(activity)
layout.setOrientation(LinearLayout.VERTICAL)
layout.setBackgroundColor(0xFFEDEDED)
layout.setPadding(16, 16, 16, 16)   
local searchEditText = AutoCompleteTextView(activity)
searchEditText.setHint("Nhập từ khoá tìm kiếm... ")
searchEditText.setPadding(8, 8, 8, 8) 
searchEditText.setTextSize(16)         
searchEditText.setTextColor(0xFF000000)
layout.addView(searchEditText)
local listView = ListView(activity)
listView.setPadding(0, 16, 0, 0) 
listView.setBackgroundColor(0xFFFFFFFF)
layout.addView(listView)
local packageManager = activity.getPackageManager()
local applications = packageManager.getInstalledApplications(PackageManager.GET_META_DATA)
local appData = {}
for i = 1, #applications -1 do
    local appInfo = applications[i]
    local appName = appInfo.loadLabel(packageManager)
    local appPackageName = appInfo.packageName
    local launchIntent = packageManager.getLaunchIntentForPackage(appPackageName)
    if launchIntent then
        appData[appName] = appPackageName
    end
end
local sortedAppData = {}
for k, v in pairs(appData) do
    table.insert(sortedAppData, k)
end
table.sort(sortedAppData)
local adapter = ArrayAdapter(activity, android.R.layout.simple_list_item_1, sortedAppData)
listView.setAdapter(adapter)
local searchResultListView = ListView(activity)
searchResultListView.setPadding(0, 16, 0, 0)
searchResultListView.setBackgroundColor(0xFFFFFFFF)
layout.addView(searchResultListView)
activity.setContentView(layout)
local function handleSearch(query)
    local filteredList = {}
for _, appName in ipairs(sortedAppData) do
        if string.lower(appName):find(string.lower(query)) then
            table.insert(filteredList, appName)
        end
    end
if #filteredList > 0 then
        local filteredAdapter = ArrayAdapter(activity, android.R.layout.simple_list_item_1, filteredList)
        searchResultListView.setAdapter(filteredAdapter)
        listView.setVisibility(View.GONE)
        searchResultListView.setVisibility(View.VISIBLE)
    else
        searchResultListView.setVisibility(View.GONE)
        listView.setVisibility(View.VISIBLE)
    end
end
searchEditText.addTextChangedListener{
    onTextChanged = function(s, start, before, count)
        local searchText = s.toString()
        handleSearch(searchText)
    end
}
searchResultListView.onItemClick = function(parent, view, position, id)
    local selectedAppName = searchResultListView.getAdapter().getItem(position)
    local selectedAppPackageName = appData[selectedAppName]
local launchIntent = packageManager.getLaunchIntentForPackage(selectedAppPackageName)
if launchIntent then
        activity.startActivity(launchIntent)
    else
        toast("Không thể khởi chạy ứng dụng đã chọn.")
    end
end
listView.onItemClick = function(parent, view, position, id)
    local selectedAppName = sortedAppData[position + 1]
    local selectedAppPackageName = appData[selectedAppName]
    local launchIntent = packageManager.getLaunchIntentForPackage(selectedAppPackageName)
    if launchIntent then
        activity.startActivity(launchIntent)
    else
        toast("Không thể khởi chạy ứng dụng đã chọn.")
    end
end
listView.onItemLongClick = function(parent, view, position, id)
    local selectedAppName = sortedAppData[position + 1]
    local selectedAppPackageName = appData[selectedAppName]
local popupMenu = PopupMenu(activity, view)
    popupMenu.menu.add("Hoạt động hiển thị")
    popupMenu.menu.add("Thông tin ứng dụng")
    popupMenu.menu.add("Gỡ cài đặt")
    popupMenu.menu.add("Chia sẻ liên kết")
    popupMenu.menu.add("Mở trong cửa hàng play")
    popupMenu.menu.add("Nhận tên gói")
    popupMenu.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener {
        onMenuItemClick = function(item)
            if item.getTitle() == "Hoạt động hiển thị" then
                displayComponents(selectedAppPackageName)
            elseif item.getTitle() == "Thông tin ứng dụng" then
                showAppInfo(selectedAppPackageName)
            elseif item.getTitle() == "Gỡ cài đặt" then
                uninstallApp(selectedAppPackageName)
            elseif item.getTitle() == "Chia sẻ liên kết" then
                sharePlayStoreLink(selectedAppPackageName)
            elseif item.getTitle() == "Mở trong cửa hàng play" then
                openInPlayStore(selectedAppPackageName)
            elseif item.getTitle() == "Nhận tên gói" then
                getPackageName(selectedAppPackageName)
            end
            return true
        end
    })    popupMenu.show()
    return true
end
activity.setContentView(layout)
listView.onItemClick = function(parent, view, position, id)
    local selectedAppName = sortedAppData[position + 1]
    local selectedAppPackageName = appData[selectedAppName]
    local launchIntent = packageManager.getLaunchIntentForPackage(selectedAppPackageName)
    if launchIntent then
        activity.startActivity(launchIntent)
    else
        toast("Không thể khởi chạy ứng dụng đã chọn.")
    end
end
local function displayComponents(selectedAppPackageName)
    local packageManager = activity.getPackageManager()
    local packageInfo = packageManager.getPackageInfo(selectedAppPackageName, PackageManager.GET_ACTIVITIES)
local componentNames = {}
if packageInfo.activities then
        for i = 1, #packageInfo.activities -1 do
            local activityInfo = packageInfo.activities[i]
            componentNames[i] = "Activity: " .. activityInfo.name
        end
    end
if packageInfo.services then
        for i = 1, #packageInfo.services do
            local serviceInfo = packageInfo.services[i - 1]
            componentNames[#componentNames + 1] = "Service: " .. serviceInfo.name
        end
    end
if packageInfo.receivers then
        for i = 1, #packageInfo.receivers -1 do
            local receiverInfo = packageInfo.receivers[i]
            componentNames[#componentNames + 1] = "Receiver: " .. receiverInfo.name
        end
    end
if packageInfo.providers then
        for i = 1, #packageInfo.providers -1 do
            local providerInfo = packageInfo.providers[i]
            componentNames[#componentNames + 1] = "Nhà cung cấp: "
        end
    end
local items = {}
    for i = 1, #componentNames do
        items[i] = componentNames[i]
    end
    local builder = AlertDialog.Builder(activity)
    builder.setTitle("Thành phần cho " .. selectedAppPackageName)
    builder.setItems(items, DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            local selectedComponent = componentNames[which + 1]
            local componentType, componentName = selectedComponent:match("([^:]+):%s(.+)")
            if componentType and componentName then
                local intent = Intent()
                intent.setComponent(ComponentName(selectedAppPackageName, componentName))
                intent.setAction(Intent.ACTION_MAIN)
                intent.addCategory(Intent.CATEGORY_LAUNCHER)
                if intent.resolveActivity(packageManager) then
                    activity.startActivity(intent)
                else
                    toast("Không thể khởi chạy thành phần đã chọn.")
                end
            end
        end
    })builder.setPositiveButton("OK", nil)
local dialog = builder.create()
    dialog.show()
end
local function showAppInfo(selectedAppPackageName)
    local intent = Intent()
    intent.setAction(Settings.ACTION_APPLICATION_DETAILS_SETTINGS)
    intent.setData(Uri.fromParts("package", selectedAppPackageName, nil))
    activity.startActivity(intent)
end
local function uninstallApp(selectedAppPackageName)
    local uninstallIntent = Intent(Intent.ACTION_UNINSTALL_PACKAGE)
    uninstallIntent.setData(Uri.fromParts("package", selectedAppPackageName, nil))
    activity.startActivity(uninstallIntent)
end
local function sharePlayStoreLink(selectedAppPackageName)
    local playStoreLink = "https://play.google.com/store/apps/details?id=" .. selectedAppPackageName
    local sendIntent = Intent()
    sendIntent.setAction(Intent.ACTION_SEND)
    sendIntent.putExtra(Intent.EXTRA_TEXT, playStoreLink)
    sendIntent.setType("text/plain")
    activity.startActivity(Intent.createChooser(sendIntent, "Chia sẻ qua"))
end
local function openInPlayStore(selectedAppPackageName)
    local intent = Intent(Intent.ACTION_VIEW)
    intent.setData(Uri.parse("market://details?id=" .. selectedAppPackageName))
    intent.setPackage("com.android.vending")
    activity.startActivity(intent)
end
local function getPackageName(selectedAppPackageName)
    local builder = AlertDialog.Builder(activity)
    builder.setTitle("Tên gói")
    builder.setMessage("Tên gói ứng dụng: " .. selectedAppPackageName)
    builder.setPositiveButton("OK", nil)
local dialog = builder.create()
    dialog.show()
end
local function shareApk(selectedAppPackageName)
    local packageManager = activity.getPackageManager()
    local packageInfo = packageManager.getPackageInfo(selectedAppPackageName, PackageManager.GET_META_DATA)
if packageInfo.applicationInfo.sourceDir then
        local apkPath = packageInfo.applicationInfo.sourceDir
        local appName = packageManager.getApplicationLabel(packageInfo.applicationInfo)
        local cleanAppName = appName:gsub("[^a-zA-Z0-9]+", "_")
        local versionName = packageInfo.versionName
        local fileName = cleanAppName .. "_v" .. versionName .. ".apk"
        local externalDir = File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS), "Chia sẻ apk")
        externalDir.mkdirs()
        local sharedApkFile = File(externalDir, fileName)
        LuaUtil.copyFile(apkPath, sharedApkFile.getAbsolutePath())
        local sendIntent = Intent()
        sendIntent.setAction(Intent.ACTION_SEND)
        sendIntent.setType("application/vnd.android.package-archive")
        sendIntent.putExtra(Intent.EXTRA_STREAM, activity.getUriForFile(sharedApkFile))
        sendIntent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION) -- Grant read permissions
activity.startActivity(Intent.createChooser(sendIntent, "Chia sẻ tệp APK"))
    end
end
local function getApiInfo(selectedAppPackageName)
    local packageManager = activity.getPackageManager()
    local packageInfo = packageManager.getPackageInfo(selectedAppPackageName, PackageManager.GET_META_DATA)
if packageInfo.applicationInfo.sourceDir then
        local apkPath = packageInfo.applicationInfo.sourceDir
        local extractDir = File(activity.getExternalFilesDir(nil), "extracted_apk")
        extractDir.mkdirs()
        LuaUtil.unZip(apkPath, extractDir.getAbsolutePath())
local function shareUnzippedApk(extractDir)
    local apkFiles = extractDir.listFiles()
    local shareIntent = Intent(Intent.ACTION_SEND_MULTIPLE)
    shareIntent.setType("application/vnd.android.package-archive")
local uris = ArrayList()
    for i = 0, #apkFiles - 1 do
        local file = apkFiles[i]
        local uri = activity.getUriForFile(file)
        uris.add(uri)
    end
shareIntent.putParcelableArrayListExtra(Intent.EXTRA_STREAM, uris)
    activity.startActivity(Intent.createChooser(shareIntent, "Chia sẻ tệp APK"))
end
local builder = AlertDialog.Builder(activity)
        builder.setTitle("Thông tin ATI cho " .. selectedAppPackageName)
        builder.setMessage("Tệp APK được trích xuất vào: " .. extractDir.getAbsolutePath())
        builder.setPositiveButton("Chia sẻ APK", DialogInterface.OnClickListener {
            onClick = function(dialog, which)
                shareUnzippedApk(extractDir)
            end
        })        builder.setNegativeButton("OK", nil)
local dialog = builder.create()
        dialog.show()
    else
        local builder = AlertDialog.Builder(activity)
        builder.setTitle("Thông tin ATI cho " .. selectedAppPackageName)
        builder.setMessage("Không có đường dẫn cho tệp APK.")
        builder.setPositiveButton("OK", nil)
local dialog = builder.create()
        dialog.show()
    end
end
searchResultListView.onItemLongClick = function(parent, view, position, id)
    local selectedAppName = searchResultListView.getAdapter().getItem(position)
    local selectedAppPackageName = appData[selectedAppName]
local popupMenu = PopupMenu(activity, view)
    popupMenu.menu.add("Hoạt động hiển thị")
    popupMenu.menu.add("Thông tin ứng dụng")
    popupMenu.menu.add("Gỡ cài đặt")
    popupMenu.menu.add("Chia sẻ liên kết")
    popupMenu.menu.add("Mở trong cửa hàng play")
    popupMenu.menu.add("Nhận tên gói")
    popupMenu.menu.add("Chia sẻ APK")
   -- popupMenu.menu.add("Nhận thông tin API")
popupMenu.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener {
        onMenuItemClick = function(item)
            if item.getTitle() == "Hoạt động hiển thị" then
                displayComponents(selectedAppPackageName)
            elseif item.getTitle() == "Thông tin ứng dụng" then
                showAppInfo(selectedAppPackageName)
            elseif item.getTitle() == "Gỡ cài đặt" then
                uninstallApp(selectedAppPackageName)
            elseif item.getTitle() == "Chia sẻ liên kết" then
                sharePlayStoreLink(selectedAppPackageName)
            elseif item.getTitle() == "Mở trong cửa hàng play" then
                openInPlayStore(selectedAppPackageName)
            elseif item.getTitle() == "Nhận tên gói" then
                getPackageName(selectedAppPackageName)
            elseif item.getTitle() == "Chia sẻ APK" then
                shareApk(selectedAppPackageName)
            elseif item.getTitle() == "Nhận thông tin ATI" then
                getApiInfo(selectedAppPackageName) -- Handle the "Get API Info" option
            end
            return true
        end
    })popupMenu.show()
    return true
end
listView.onItemLongClick = function(parent, view, position, id)
    local selectedAppName = sortedAppData[position + 1]
    local selectedAppPackageName = appData[selectedAppName]
local popupMenu = PopupMenu(activity, view)
    popupMenu.menu.add("Hoạt động hiển thị")
    popupMenu.menu.add("Thông tin ứng dụng")
    popupMenu.menu.add("Gỡ cài đặt")
    popupMenu.menu.add("Chia sẻ liên kết")
    popupMenu.menu.add("Mở trong cửa hàng play")
    popupMenu.menu.add("Nhận tên gói")
    popupMenu.menu.add("Chia sẻ APK")
   -- popupMenu.menu.add("Nhận thông tin API")
popupMenu.setOnMenuItemClickListener(PopupMenu.OnMenuItemClickListener {
        onMenuItemClick = function(item)
            if item.getTitle() == "Hoạt động hiển thị" then
                displayComponents(selectedAppPackageName)
            elseif item.getTitle() == "Thông tin ứng dụng" then
                showAppInfo(selectedAppPackageName)
            elseif item.getTitle() == "Gỡ cài đặt" then
                uninstallApp(selectedAppPackageName)
            elseif item.getTitle() == "Chia sẻ liên kết" then
                sharePlayStoreLink(selectedAppPackageName)
            elseif item.getTitle() == "Mở trong cửa hàng play" then
                openInPlayStore(selectedAppPackageName)
            elseif item.getTitle() == "Nhận tên gói" then
                getPackageName(selectedAppPackageName)
            elseif item.getTitle() == "Chia sẻ APK" then
                shareApk(selectedAppPackageName)
            elseif item.getTitle() == "Nhận thông tin API" then
                getApiInfo(selectedAppPackageName) -- Handle the "Get API Info" option
            end
            return true
        end
    })popupMenu.show()
    return true
end
activity.setContentView(layout)